require "./AI/USER_AI/moblist.lua"

--------------------------------------------------
--
-- zNXpU胂W[
--
--	MyMobList.lua
--
--	var.2006/08/16
--
--------------------------------------------------
-- constants # 萔 #
--------------------------------------------------
M_V_ACTION		= 1	-- # zs #
M_V_SKILL		= 2	-- # XLs #
M_V_PRIORITY		= 3	-- # UDx #

--------------------------------------------------
-- # zs #
--------------------------------------------------
M_ACTION_NONE		= 0	-- Ȃ
M_ACTION_ATTACK		= 1	-- U
M_ACTION_COUNTER	= 2 	-- Uꂽ甽
M_ACTION_OWNER		= 3	-- 傪Uꂽ甽

M_ACTION_ESCAPE		= 9	-- 

--------------------------------------------------
-- # XLs #
--------------------------------------------------
M_SKILL_NONE		= 0	-- XLUȂ
M_SKILL_FIRST		= 1	-- XLU
M_SKILL_COMBO		= 2	-- XLU
M_SKILL_ONLY		= 3	-- XLÛ

--------------------------------------------------
-- # UDx #
--------------------------------------------------
M_PRIORITY_FIRST	= 1	-- UDx 
M_PRIORITY_SECOND	= 2	-- UDx 
M_PRIORITY_THIRD	= 3	-- UDx 
M_PRIORITY_NONE		= 4	-- UDx 

--------------------------------------------------
---- # ftHgs #
--------------------------------------------------
M_DEFAULT_A	= M_ACTION_NONE		-- o^ĂȂmobւ̃zs
M_DEFAULT_S	= M_SKILL_NONE		-- o^ĂȂmobւ̃XLs
M_DEFAULT_P	= M_PRIORITY_THIRD	-- o^ĂȂmob̍UDx

--------------------------------------------------
-- 
--------------------------------------------------
--[[
function OnATTACK_ST ()

	``
	
	if OnAutoSkill (MyEnemy) then			-- XLU邩
		Attack (MyID,MyEnemy)			-- U
	end
end

function OnAutoSkill (id)
	local MyOwner = GetV (0, 0)
	if (GetSkillAction (id) ~= 0) then return false end				-- XLUȂ
	if (GetV (V_MOTION, MyOwner) == MOTION_SIT or AutoSkillLv == 0) then		-- P~Ă牽Ȃ
		return false
	end
	local target = GetV (V_TARGET, id)
	if (target ~= MyOwner and target ~= MyID and target ~= 0) then			-- ^QP~AzAt[łȂ
		return false
	end
	local skill, delay, sp = 0, 0, 0
	if (math.mod (GetV (V_HOMUNTYPE, MyID), 4) == 3) then				-- ztB[nȂ
		skill = 8009
		delay = 1200
		sp = AutoSkillLv * 4
	elseif (math.mod (GetV (V_HOMUNTYPE, MyID), 4) == 0) then			-- zoj~gnȂ
		skill  = 8013
		delay = 1800
		sp = 20 + AutoSkillLv * 2
	end
	if (SkillCount < GetTick ()) then						-- Ԃo߂Ă
		if (GetV (V_SP, MyID) < sp) then return false end			-- SPsĂ
		if (GetSkillAction (id) == 2) then					-- XLU
			if (GetRate(sp) < math.random (BaseRate)) then			-- m
				return false
			end
		end
		SkillObject (MyID, AutoSkillLv, skill, id)				-- XLgp
		SkillCount = GetTick () + delay						-- JEgXV
		return true
	end
	return false
end

function GetEnemyEx () -- ANeBuG
	local actors = GetActors ()
	local enemys = {}
	local badtargets = {}
	local result = 0
	local target
	for i,v in ipairs (actors) do
		if (IsEenemy (v) == 1) then						-- U\Ώۂ
			target = GetV (V_TARGET, v)					-- ^Q擾
			if (target == MyOwner and target == MyID and target == 0) then	-- P~AzAt[
				enemys[v] = GetDistance2 (MyID, v)			-- G̃Xgɋǉ
			end
		elseif (v ~= MyOwner and 100000 < v) then				-- vC[
			target = GetV (V_TARGET, v)					-- ^Q擾
			if (IsEenemy (target) == 1) then				-- U\Ώۂ
				badtargets[target] = v					-- UΏۂɒǉ
			end
		elseif (v ~= MyID and IsHomunkulus (v) == 1) then			-- z
			target = GetV (V_TARGET, v)					-- ^Q擾
			if (IsEenemy (target) == 1) then				-- U\Ώۂ
				badtargets[target] = v					-- UΏۂɒǉ
			end
		end
	end
	local min_dis = 10
	for v,i in pairs (enemys) do
		for w,j in pairs (badtargets) do
			if (i < min_dis and 3 < GetDistance2 (MyID, w)) then		-- ŏ߂L牓
				if not badtargets[v] then				-- L̃^QłȂ
					result = v					-- ̓G^[QbgƂ
					min_dis = i					-- ̓GƂ̋ŏƂ
				end
			end
		end
	end
	return result
end

function IsHomunkulus (id)
	local Ty = GetV (7, id)
	if (0 < Ty and Ty < 17 and id < 100000) then	-- zID͈͂vC[͈͂łȂ
		return 1
	else
		return 0
	end
end

ISPLANT = {[1078]=1,[1079]=1,[1080]=1,[1081]=1,[1082]=1,[1083]=1,[1084]=1,[1085]=1,	-- LmR
	[1555]=1,[1575]=1,[1579]=1,[1589]=1,[1590]=1}					-- oCIvg
ISEGG = {[1008]=1,[1047]=1,[1048]=1,[1097]=1,[1142]=1,[1236]=1,[1721]=1}		-- CN
function IsPlant (id)
	if (100000 < id) then return 0 end
	local Ty = GetV(7,id)
	if ISPLANT[Ty] then return 1 end						-- oCIvgLmR
--	if ISEGG[Ty] then return 1 end							-- CN
	return 0
end

function IsEenemy (id)
	local Ty = GetV (V_HOMUNTYPE, id)
	if IsMonster (id) == 0 then return 0 end					-- U\Ώ
	if Ty < 1000 then return 0 end							-- GID͈
	if 2000 < Ty then return 0 end							-- GID͈
	if IsPlant (id) == 1 then return 0 end						-- oCIvgLmR
	if GetV (V_MOTION, id) == MOTION_DEAD then return 0 end				-- S[V
	return 1
end

]]--
--------------------------------------------------

MOBNAME = {[[XR[sI]],[[|]],nil,[[z[lbg]],[[t@~A]],nil,[[t@u]],[[vp]],[[Rh]],[[EB[]],[[``]],[[b_tbO]],[[Et]],[[X|A]],[[]r]],[[A[`[XPg]],nil,[[N[~[]],[[yRyR]],[[}hS]],nil,nil,[[I[NEHA[]],[[[e[]],[[XlCN]],[[ibN]],nil,[[\W[XPg]],[[CVX]],[[AiR_N]],[[||]],[[xbg]],[[G_[EB[]],[[^tbO]],[[n^[tC]],[[O[]],[[TChC_[]],[[IVX]],[[otHbg]],[[S[]],[[}~[]],[[X`[``]],nil,[[I{k]],[[}N]],[[hbyQK[]],[[yRyR̗]],[[X峂̗]],[[sbL]],[[sbL]],[[X]],[[bJ[]],[[X峁ij]],[[X峁iYj]],[[J[]],[[X[L[]],[[[[]],[[^]],[[~XgX]],[[rbOtbg]],[[iCgA]],[[T^|]],[[ieBbN]],[[Kh]],[[XgEt]],[[oh]],[[JigEX]],[[qh]],[[\[htBbV]],[[NN]],[[pC[cXP]],[[Jz]],[[Jj]],[[L]],nil,[[XPg]],[[|CYX|A]],[[Ԃ]],[[]],[[ΐF]],[[F]],[[]],[[P]],[[̂]],[[Ԃ̂]],[[]],[[I[Nq[[]],[[{[J]],[[g[h]],[[}X^[O]],[[hStC]],[[炢T]],[[GNvX]],[[Ao[iCg]],[[Ah]],[[GWFO]],[[a̗]],nil,[[AMIy]],[[ASX]],[[otHbg.Jr]],[[o[X[]],[[L]],[[R[R[]],[[fj[]],[[fU[gEt]],[[fU[gEtiqj]],[[frAX]],[[fr`]],[[hPr]],[[hCA[]],[[hCN]],[[hbvX]],[[_XeBlX]],[[GhK]],[[GM]],[[CrhCh]],[[t[]],[[th]],[[S[XgO]],[[KCAX]],[[Sujij]],[[Sujij]],[[SuOjij]],[[SuljiƁj]],[[Suܒji{j]],[[z[h]],[[z]],[[z]],[[WbN]],[[W[J[]],[[J[bco[O]],[[R{hjij]],[[R{hjiƁj]],[[R{hOji{j]],nil,nil,[[@]],[[}eBX]],[[}hD[N]],[[}i]],[[}XtBA[]],[[}Ilbg]],[[}X]],[[}[eB]],[[}[^[]],[[}]],[[f[T]],[[~m^EX]],[[]],[[~Xg]],[[I[NXPg]],[[I[N]r]],[[pTi]],[[veBbginj]],[[veBbgij]],[[t@I]],[[tF]],[[tIj]],[[sG[]],[[vNg]],[[tVA]],[[ChbN]],[[NCG]],[[Th}]],[[Tx[W]],[[Tx[Wxx]],nil,[[XP[J[]],[[\q[]],nil,nil,nil,[[X^Ci[]],[[^E]],[[r^^]],[[[m[N]],[[[]],[[EBXp[]],[[]],nil,nil,nil,nil,[[EBXp[(O1)]],[[EBXp[]],nil,[[{S]],[[I[NA[`[]],[[I[N[h]],[[~~bN]],[[CX]],[[A[]],[[ANEX]],[[Ch[h]],[[XPvYi[]],[[]rvYi[]],[[_[Nv[Xg]],[[pN]],[[W^X]],[[rI]],[[tF_[N]],[[~XeeC]],[[I[KgD[X]],[[GNXL[Vi[]],[[AmA]],[[XeBO]],[[fr]],[[Nv]],nil,[[uCg]],nil,[[nCI[N]],[[`R]],[[Xe[]],[[ymi]],nil,nil,[[[̋Rm]],nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,[[a̗]],nil,nil,nil,nil,nil,[[}[]],[[TXJb`]],[[NX}XWbN]],[[NX}XSu]],[[NX}XNbL[]],[[A\j]],[[N[U[]],[[~XgP[X]],[[`Fybg]],[[Xg[iCg]],[[neB[]],[[K[SC]],[[O]],[[lCh]],[[yXg]],[[CWXeBX]],[[SuA[`[]],[[OtH]],[[_[Nt[]],[[Ch[Y]],[[~[^ghS]],[[EBhS[Xg]],[[l]],[[NbL[]],[[qgf]],[[WFX^[]],[[ubfBiCg]],[[NbN]],[[vǗ]],[[AQ[^[]],[[_[N[h]],[[I[NfB]],[[KX]],[[AX]],[[ChbNA[`[]],[[V叫R]],[[X^N^CgS[]],[[Ot]],[[SuC_[]],[[Z[W[]],[[R{hA[`[]],[[L]],nil,[[K[fBAi|j]],[[K[fBAiRj]],[[K[fBAij]],[[GyE]],[[}p[v]],[[WFlXPg]],[[fbh[CX]],[[~jf]],[[N[~[tBA[]],[[L[}eBX]],[[IEo]],[[R{h[_[]],[[GVFg}~[]],[[]r}X^[]],[[Su[_[]],[[L^s[]],[[Ag]],[[_[NC[W]],[[WCAgz[lbg]],[[WCAgXpC_[]],[[GVFg[]],[[CuI}C]],[[LbgiCeC]],[[pc@[Su]],[[KW}[g]],[[~m^EX]],[[OuXeB]],[[^[gWFl]],[[`s]],[[p[bg^[g]],[[ATg^[g]],[[\bh^[g]],[[Ibg[]],[[q[g^[g]],[[t[Y^[g]],[[IEf[N]],[[hSeC]],[[XvOrbg]],[[V[Ib^[]],nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,[[ATg^[g(g)]],[[A|JvX]],[[[@S[]],[[uCU[]],[[WIOt@[]],[[OyR]],[[TLoX]],[[tFCNGWF]],[[S[g]],[[[hIufX]],[[CLoX]],[[ꔽؖ]],[[n[s[]],[[G_[]],[[f[pN]],[[iCgAe[]],[[h[]],[[OY[]],[[fBA{bN]],[[GNXv[W]],[[f[^[ij]],[[f[^[inj]],[[X[p[]],[[MO]],[[A[NGWFO]],[[hL]],[[@CI[]],[[KpS]],[[[^[WC]],nil,nil,nil,nil,nil,nil,nil,[[JP]],[[JuLE]],[[^]],[[e]],[[l`]],[[V]],[[͓]],nil,[[ps]],[[cqq]],[[lʓ]],nil,[[Vאl]],[[VlQ]],nil,[[RE]],[[V喺X]],[[`bL[]],[[։]],[[߂܂(t@~A)]],[[X_A[`[XPg]],[[(CVX)]],[[(n^[tC)]],[[(O[)]],[[C(TChC_[)]],[[E(I{k)]],[[₽(}N)]],[[(iCgA)]],[[H(|CYX|A)]],[[S(AMIy)]],[[(ASX)]],[[_(otHbg.Jr)]],[[a(fU[gEt)]],[[uS(fr`)]],[[n(hCA[)]],[[(CrhCh)]],[[M(WbN)]],[[(W[J[)]],[[(J[bco[O)]],[[(nCI[N)]],[[^}lM(Xe[)]],[[(ymi)]],[[g(TXJb`)]],[[(N[U[)]],[[}b`̏(`Fybg)]],[[X_O]],[[(CWXeBX)]],[[l(OtH)]],[[(_[Nt[)]],[[ˑRψٗ(~[^ghS)]],[[(EBhS[Xg)]],[[O(l)]],[[X_I[NfB]],[[|(ChbNA[`[)]],[[(Ot)]],[[I(R{hA[`[)]],[[b(L)]],[[؂菝(}eBX)]],[[Վi(}hD[N)]],[[l`(}Ilbg)]],[[ubNhbO(}[^[)]],[[(~m^EX)]],[[T}G(I[NXPg)]],[[I[N]r]],[[Mj(pTi)]],[[ŗ(veBbg(n))]],[[(veBbg())]],[[Z(ChbN)]],[[NCG]],[[JQCV(XP[J[)]],[[X_[]],[[эj()]],[[LEV({S)]],[[Ăx(I[NA[`[)]],[[tr_(~~bN)]],[[(CX)]],[[ؓ(A[)]],[[(ANEX)]],[[{(Ch[h)]],[[S(XPv]i[)]],[[X_]rvYi[]],[[(pN)]],[[(W^X)]],[[ÎE(rI)]],[[(tF_[N)]],[[m(~XeBeB)]],[[(I[KgD[X)]],[[Ysl(GNXL[Wi[)]],[[(AmA)]],[[(XeBO)]],[[(fr)]],[[X_hPr]],[[앐m]],[[hA[h]],[[r[g]],[[tCV[^[]],nil,[[EhDS[]],[[E[^V[^[]],[[E[^t@C^[]],[[tFA[t]],nil,nil,[[Wrbg]],[[fn]],[[]],[[fBXKCY]],[[ubfB}[_[]],[[L[u]],[[[h]],[[nC[]CXg]],[[A[]],[[qFO]],[[~OF]],[[]],[[neB[xx]],[[y]],[[Րl]],nil,nil,nil,[[X_AX]],[[X_GVFg}~[]],[[X_e]],[[X_RE]],[[X_o[X[]],[[X_ps]],[[X_vǗ]],[[X_NbN]],[[X_։]],[[X_hL]],[[X_Vl]],[[X_GNXv[W]],[[X_Ibg[]],[[X_Sujij]],[[X_Sujij]],[[X_SuOjij]],[[X_SuljiƁj]],[[X_Suܒji{j]],[[X_Su[_[]],[[X_S[]],[[X_V叫R]],[[X_앐m]],[[X_͓]],[[X_JP]],[[X_R{hjij]],[[X_R{hjiƁj]],[[X_R{hOji{j]],[[X_R{h[_[]],[[X_[@S[]],[[X_lʓ]],[[X_}X]],[[X_l`]],[[X_~Xg]],[[X_iCgA]],[[tFA[tiP~j]],[[X_^]],[[X_[^[WC]],[[X_Th}]],[[X_XR[sI]],[[X_JuLE]],[[X_X[L[]],nil,[[X_V]],[[X_V喺X]],[[X_VlQ]],[[X_fbh[CX]],[[X_GVFg[]],[[X_GWFO]],[[X_ubfBiCg]],[[X_Nv]],[[X_frAX]],[[X_hbvX]],[[X_G_[]],[[X_G_[EB[]],[[t[iP~j]],[[X_S[XgO]],[[X_SuA[`[]],[[X_z]],[[qhiP~j]],[[X_CLoX]],[[X_{[J]],[[frO]],[[^IOK]],[[^]],nil,[[[tLbg]],[[Nx]],[[NX}XI[N]],[[}hSiP~j]],[[WIOt@[iP~j]],[[X_ieBbN]],[[`siqj]],[[X_GVFg}~[]],[[X_t[Y^[g]],[[X_}[]],[[X_^A]],[[X_K[SC]],[[X_uCU[]],[[X_EBXp[]],[[X_q[g^[g]],[[X_p[bg^[g]],[[X_\bh^[g]],[[X_rbNtbg]],[[X_WCAgz[lbg]],[[X__[NC[W]],[[X_neB[xx]],[[X_NX}XSu]],[[X_Y]],[[X__VOhS]],[[X_ibN]],[[X_{S]],[[X_qFO]],[[^]],[[~l]],[[IvVfBA]],[[sbg}]],[[WN|bg]],[[ESAg]],[[|ZI]],[[mNVX]],[[׃m}X]],[[xAh[]],[[RSX-0806]],[[X_WN|bg]],[[X_|ZI]],nil,[[EBX]],[[f]],[[qEBhij]],[[yN\W]],[[`C[]],[[O]],[[rz_[]],[[ZC=EBU[]],[[GX=KC]],[[n[h=AgAC[]],[[}[Kb^=\]],[[ZV=fB]],[[Jg[k=PC]],[[ZC=EBU[]],[[GX=KC]],[[n[hAg=AC[]],[[}[Kb^=\]],[[ZV=fB]],[[Jg[k=PC]],[[ZC=EBU[]],[[GX=KC]],[[n[h=AgAC[]],[[}[Kb^=\]],[[ZV=fB]],[[Jg[k=PC]],[[COj[=ZjA]],[[qbPoC=gX]],[[A}CA=f[]],[[Ch=GxV]],[[J@N=CJX]],[[E=B_[]],[[COj[=ZjA]],[[X_qbPoC=gX]],[[X_A}CA=f[]],[[X_Ch=GxV]],[[X_J@N=CJX]],[[X_E=B_[]],nil,nil,nil,nil,[[A[N_]],[[X_fB~bNij]],[[fB~bNij]],[[fB~bNij]],[[fB~bNinj]],[[fB~bNi΁j]],[[Q[g䑕u]],[[X_Fi[gi΁j]],[[Fi[gij]],[[Fi[gij]],[[Fi[ginj]],[[Fi[gij]],[[qEBhij]],[[WF~j-S58]],[[[o]],[[X_tHgLm]],[[X_A[N_]],[[FXp[]],[[I[Nxr[]],[[O[COAi]],[[fB[^j[]],nil,nil,nil,[[u[Y]],[[vY}iOj]],[[vY}i΁j]],[[vY}inj]],[[vY}iŁj]],[[vY}ij]],[[fX[h]],[[GVFg~~bN]],[[Ď]],[[ی삷]],[[s]],[[ԘJ]],[[^igX̑]],'^igX̐]',[[^igX̔߂]],[[^igX̋Y]],[[m^igX̎vO]],[[X_^igX̑]],'X_^igX̐]',[[X_^igX̔߂]],[[X_^igX̋Y]],[[IVhXij]],[[yXi΁j]],[[m[oXiԁj]],[[IVhXij]],[[yXinj]],[[m[oXij]],[[f[^UEX]],[[nChT[]],[[hS̗]]}

--------------------------------------------------
function IsMorePriority (id1, id2)
	local p1 = GetMobSetting (M_V_PRIORITY, id1)
	local p2 = GetMobSetting (M_V_PRIORITY, id2)
	if p1 < p2 then
		return id1
	elseif p1 == p2 and GetDistance2 (MyID, id1) <= GetDistance2 (MyID, id2) then
		return id1
	end
	return id2
end

function IsMostPriority (actors)
	local result = 0
	local min_pri = 4
	local pri
	local min_dis = 20
	local dis
	for i,v in ipairs(actors) do
		pri = GetMobSetting (M_V_PRIORITY, v)
		dis = GetDistance2 (MyID, v)
		if (pri < min_pri) then
			result = v
			min_pri = pri
		elseif (pri == min_pri and dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	return result
end

function IsNonAttack (id)
	if (GetAttackAction (id) == 0 or GetAttackAction (id) == 9) then
		return true
	end
	return false
end

function IsNonSkill (id)
	if (GetSkillAction (id) == 0) then
		return true
	end
	return false
end

function GetMobSetting (const, id)
	local data = GetMobList (id)
	return data[const]
end

function SetMobList (id, a, s, p)
	a = a or M_DEFAULT_A
	s = s or M_DEFAULT_S
	p = p or M_DEFAULT_P
	MYMOB[id] = {a, s, p}
	SaveMobList (id)
end

function GetMobList (id)
	local Ty = GetV (7, id)
	if MYMOB[Ty] then
		return MYMOB[Ty]
	end
	return {M_DEFAULT_A, M_DEFAULT_S, M_DEFAULT_P}
end

function SaveMobList (id)
	if id then
		fp = io.open ("AI/USER_AI/substatus.lua", "a")
		if (fp == nil) then return end
		fp:write (string.format ("MYMOB[%d]={%d,%d,%d}\n", id, MYMOB[id][1], MYMOB[id][2], MYMOB[id][3]))
		fp:close ()
	else
		fp = io.open ("AI/USER_AI/substatus.lua", "w+")
		if (fp == nil) then return end
		fp:write (string.format ("MYMOB={\n"))
		for i, v in pairs (MYMOB) do
			fp:write (string.format ("[%d]={%d,%d,%d},\n", i, v[1], v[2], v[3]))
--			fp:write (string.format ("[%d]={%d,%d,%d}, -- %s\n", i, v[1], v[2], v[3], MOBNAME[i]))
		end
		fp:write (string.format ("}\n"))
		fp:close ()
	end
end
